diff --git a/strongswan-5.2.0/src/include/linux/pfkeyv2.h b/strongswan-5.2.0/src/include/linux/pfkeyv2.h
index 7379d1a..01da2f7 100644
--- a/strongswan-5.2.0/src/include/linux/pfkeyv2.h
+++ b/strongswan-5.2.0/src/include/linux/pfkeyv2.h
@@ -3,6 +3,28 @@
  * file will not be compliant.
  */
 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
+
 #ifndef _LINUX_PFKEY2_H
 #define _LINUX_PFKEY2_H
 
@@ -296,6 +318,10 @@ struct sadb_x_kmaddress {
 #define SADB_X_AALG_SHA2_512HMAC	7
 #define SADB_X_AALG_RIPEMD160HMAC	8
 #define SADB_X_AALG_AES_XCBC_MAC	9
+#define SADB_X_AALG_BELT_HASH		10
+#define SADB_X_AALG_GOST_MAC		11
+#define SADB_X_AALG_BELT_MAC		12
+#define SADB_X_AALG_BELT_HMAC		13
 #define SADB_X_AALG_NULL		251	/* kame */
 #define SADB_AALG_MAX			251
 
@@ -304,7 +330,7 @@ struct sadb_x_kmaddress {
 #define SADB_EALG_DESCBC		2
 #define SADB_EALG_3DESCBC		3
 #define SADB_X_EALG_CASTCBC		6
-#define SADB_X_EALG_BLOWFISHCBC		7
+#define SADB_X_EALG_BLOWFISHCBC	7
 #define SADB_EALG_NULL			11
 #define SADB_X_EALG_AESCBC		12
 #define SADB_X_EALG_AESCTR		13
@@ -316,6 +342,13 @@ struct sadb_x_kmaddress {
 #define SADB_X_EALG_AES_GCM_ICV16	20
 #define SADB_X_EALG_CAMELLIACBC		22
 #define SADB_X_EALG_NULL_AES_GMAC	23
+#define SADB_X_EALG_GOST28147_ECB	24
+#define SADB_X_EALG_GOST28147_CTR	25
+#define SADB_X_EALG_GOST28147_CFB	26 
+#define SADB_X_EALG_BELT_ECB		27 
+#define SADB_X_EALG_BELT_CBC		28 
+#define SADB_X_EALG_BELT_CFB		29 
+#define SADB_X_EALG_BELT_CTR		30 
 #define SADB_EALG_MAX                   253 /* last EALG */
 /* private allocations should use 249-255 (RFC2407) */
 #define SADB_X_EALG_SERPENTCBC  252     /* draft-ietf-ipsec-ciph-aes-cbc-00 */
diff --git a/strongswan-5.2.0/src/libcharon/Makefile.am b/strongswan-5.2.0/src/libcharon/Makefile.am
index e81c424..564dba5 100644
--- a/strongswan-5.2.0/src/libcharon/Makefile.am
+++ b/strongswan-5.2.0/src/libcharon/Makefile.am
@@ -151,8 +151,6 @@ if USE_WINDOWS
   libcharon_la_LIBADD += -lws2_32
 endif
 
-EXTRA_DIST = Android.mk
-
 # compile options
 #################
 
@@ -174,10 +172,10 @@ else
 SUBDIRS = .
 endif
 
-if USE_LOAD_TESTER
-  SUBDIRS += plugins/load_tester
+if USE_DHCP
+  SUBDIRS += plugins/dhcp
 if MONOLITHIC
-  libcharon_la_LIBADD += plugins/load_tester/libstrongswan-load-tester.la
+  libcharon_la_LIBADD += plugins/dhcp/libstrongswan-dhcp.la
 endif
 endif
 
@@ -188,27 +186,6 @@ if MONOLITHIC
 endif
 endif
 
-if USE_SOCKET_DYNAMIC
-  SUBDIRS += plugins/socket_dynamic
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/socket_dynamic/libstrongswan-socket-dynamic.la
-endif
-endif
-
-if USE_SOCKET_WIN
-  SUBDIRS += plugins/socket_win
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/socket_win/libstrongswan-socket-win.la
-endif
-endif
-
-if USE_FARP
-  SUBDIRS += plugins/farp
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/farp/libstrongswan-farp.la
-endif
-endif
-
 if USE_STROKE
   SUBDIRS += plugins/stroke
 if MONOLITHIC
@@ -216,38 +193,17 @@ if MONOLITHIC
 endif
 endif
 
-if USE_VICI
-  SUBDIRS += plugins/vici
+if USE_EAP_BSTS
+  SUBDIRS += plugins/eap_bsts
 if MONOLITHIC
-  libcharon_la_LIBADD += plugins/vici/libstrongswan-vici.la
+  libcharon_la_LIBADD += plugins/eap_bsts/libstrongswan-eap-bsts.la
 endif
 endif
 
-if USE_SMP
-  SUBDIRS += plugins/smp
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/smp/libstrongswan-smp.la
-endif
-endif
-
-if USE_SQL
-  SUBDIRS += plugins/sql
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/sql/libstrongswan-sql.la
-endif
-endif
-
-if USE_DNSCERT
-  SUBDIRS += plugins/dnscert
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/dnscert/libstrongswan-dnscert.la
-endif
-endif
-
-if USE_IPSECKEY
-  SUBDIRS += plugins/ipseckey
+if USE_KERNEL_LIBIPSEC
+  SUBDIRS += plugins/kernel_libipsec
 if MONOLITHIC
-  libcharon_la_LIBADD += plugins/ipseckey/libstrongswan-ipseckey.la
+  libcharon_la_LIBADD += plugins/kernel_libipsec/libstrongswan-kernel_libipsec.la
 endif
 endif
 
@@ -256,368 +212,4 @@ if USE_UPDOWN
 if MONOLITHIC
   libcharon_la_LIBADD += plugins/updown/libstrongswan-updown.la
 endif
-endif
-
-if USE_EAP_IDENTITY
-  SUBDIRS += plugins/eap_identity
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_identity/libstrongswan-eap-identity.la
-endif
-endif
-
-if USE_EAP_SIM
-  SUBDIRS += plugins/eap_sim
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_sim/libstrongswan-eap-sim.la
-endif
-endif
-
-if USE_EAP_SIM_FILE
-  SUBDIRS += plugins/eap_sim_file
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_sim_file/libstrongswan-eap-sim-file.la
-endif
-endif
-
-if USE_EAP_SIM_PCSC
-  SUBDIRS += plugins/eap_sim_pcsc
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_sim_pcsc/libstrongswan-eap-sim-pcsc.la
-endif
-endif
-
-if USE_EAP_SIMAKA_SQL
-  SUBDIRS += plugins/eap_simaka_sql
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_simaka_sql/libstrongswan-eap-simaka-sql.la
-endif
-endif
-
-if USE_EAP_SIMAKA_PSEUDONYM
-  SUBDIRS += plugins/eap_simaka_pseudonym
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_simaka_pseudonym/libstrongswan-eap-simaka-pseudonym.la
-endif
-endif
-
-if USE_EAP_SIMAKA_REAUTH
-  SUBDIRS += plugins/eap_simaka_reauth
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_simaka_reauth/libstrongswan-eap-simaka-reauth.la
-endif
-endif
-
-if USE_EAP_AKA
-  SUBDIRS += plugins/eap_aka
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_aka/libstrongswan-eap-aka.la
-endif
-endif
-
-if USE_EAP_AKA_3GPP2
-  SUBDIRS += plugins/eap_aka_3gpp2
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_aka_3gpp2/libstrongswan-eap-aka-3gpp2.la
-endif
-endif
-
-if USE_SIMAKA
-if MONOLITHIC
-  # otherwise this library is linked to both the eap_aka and the eap_sim plugin
-  libcharon_la_LIBADD += $(top_builddir)/src/libsimaka/libsimaka.la
-endif
-endif
-
-if USE_EAP_MD5
-  SUBDIRS += plugins/eap_md5
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_md5/libstrongswan-eap-md5.la
-endif
-endif
-
-if USE_EAP_GTC
-  SUBDIRS += plugins/eap_gtc
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_gtc/libstrongswan-eap-gtc.la
-endif
-endif
-
-if USE_EAP_MSCHAPV2
-  SUBDIRS += plugins/eap_mschapv2
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_mschapv2/libstrongswan-eap-mschapv2.la
-endif
-endif
-
-if USE_EAP_DYNAMIC
-  SUBDIRS += plugins/eap_dynamic
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_dynamic/libstrongswan-eap-dynamic.la
-endif
-endif
-
-if USE_EAP_RADIUS
-  SUBDIRS += plugins/eap_radius
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_radius/libstrongswan-eap-radius.la
-endif
-endif
-
-if USE_EAP_TLS
-  SUBDIRS += plugins/eap_tls
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_tls/libstrongswan-eap-tls.la
-endif
-endif
-
-if USE_EAP_TTLS
-  SUBDIRS += plugins/eap_ttls
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_ttls/libstrongswan-eap-ttls.la
-endif
-endif
-
-if USE_EAP_PEAP
-  SUBDIRS += plugins/eap_peap
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_peap/libstrongswan-eap-peap.la
-endif
-endif
-
-if USE_EAP_TNC
-  SUBDIRS += plugins/eap_tnc
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/eap_tnc/libstrongswan-eap-tnc.la
-endif
-endif
-
-if USE_TLS
-if MONOLITHIC
-  # otherwise this library is linked to eap_tls
-  libcharon_la_LIBADD += $(top_builddir)/src/libtls/libtls.la
-endif
-endif
-
-if USE_RADIUS
-if MONOLITHIC
-  # otherwise this library is linked to eap_radius
-  libcharon_la_LIBADD += $(top_builddir)/src/libradius/libradius.la
-endif
-endif
-
-if USE_TNC_IFMAP
-  SUBDIRS += plugins/tnc_ifmap
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/tnc_ifmap/libstrongswan-tnc-ifmap.la
-endif
-endif
-
-if USE_TNC_PDP
-  SUBDIRS += plugins/tnc_pdp
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/tnc_pdp/libstrongswan-tnc-pdp.la
-endif
-endif
-
-if USE_LIBTNCCS
-if MONOLITHIC
-  # otherwise this library is linked to the respective plugins
-  libcharon_la_LIBADD += $(top_builddir)/src/libtnccs/libtnccs.la
-endif
-endif
-
-if USE_MEDSRV
-  SUBDIRS += plugins/medsrv
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/medsrv/libstrongswan-medsrv.la
-endif
-endif
-
-if USE_MEDCLI
-  SUBDIRS += plugins/medcli
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/medcli/libstrongswan-medcli.la
-endif
-endif
-
-if USE_DHCP
-  SUBDIRS += plugins/dhcp
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/dhcp/libstrongswan-dhcp.la
-endif
-endif
-
-if USE_OSX_ATTR
-  SUBDIRS += plugins/osx_attr
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/osx_attr/libstrongswan-osx-attr.la
-endif
-endif
-
-if USE_ANDROID_DNS
-  SUBDIRS += plugins/android_dns
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/android_dns/libstrongswan-android-dns.la
-endif
-endif
-
-if USE_ANDROID_LOG
-  SUBDIRS += plugins/android_log
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/android_log/libstrongswan-android-log.la
-endif
-endif
-
-if USE_MAEMO
-  SUBDIRS += plugins/maemo
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/maemo/libstrongswan-maemo.la
-endif
-endif
-
-if USE_HA
-  SUBDIRS += plugins/ha
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/ha/libstrongswan-ha.la
-endif
-endif
-
-if USE_KERNEL_LIBIPSEC
-  SUBDIRS += plugins/kernel_libipsec
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/kernel_libipsec/libstrongswan-kernel-libipsec.la
-endif
-endif
-
-if USE_KERNEL_WFP
-  SUBDIRS += plugins/kernel_wfp
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/kernel_wfp/libstrongswan-kernel-wfp.la
-endif
-endif
-
-if USE_KERNEL_IPH
-  SUBDIRS += plugins/kernel_iph
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/kernel_iph/libstrongswan-kernel-iph.la
-endif
-endif
-
-if USE_WHITELIST
-  SUBDIRS += plugins/whitelist
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/whitelist/libstrongswan-whitelist.la
-endif
-endif
-
-if USE_LOOKIP
-  SUBDIRS += plugins/lookip
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/lookip/libstrongswan-lookip.la
-endif
-endif
-
-if USE_ERROR_NOTIFY
-  SUBDIRS += plugins/error_notify
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/error_notify/libstrongswan-error-notify.la
-endif
-endif
-
-if USE_CERTEXPIRE
-  SUBDIRS += plugins/certexpire
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/certexpire/libstrongswan-certexpire.la
-endif
-endif
-
-if USE_SYSTIME_FIX
-  SUBDIRS += plugins/systime_fix
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/systime_fix/libstrongswan-systime-fix.la
-endif
-endif
-
-if USE_LED
-  SUBDIRS += plugins/led
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/led/libstrongswan-led.la
-endif
-endif
-
-if USE_DUPLICHECK
-  SUBDIRS += plugins/duplicheck
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/duplicheck/libstrongswan-duplicheck.la
-endif
-endif
-
-if USE_COUPLING
-  SUBDIRS += plugins/coupling
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/coupling/libstrongswan-coupling.la
-endif
-endif
-
-if USE_RADATTR
-  SUBDIRS += plugins/radattr
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/radattr/libstrongswan-radattr.la
-endif
-endif
-
-if USE_UCI
-  SUBDIRS += plugins/uci
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/uci/libstrongswan-uci.la
-endif
-endif
-
-if USE_ADDRBLOCK
-  SUBDIRS += plugins/addrblock
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/addrblock/libstrongswan-addrblock.la
-endif
-endif
-
-if USE_UNITY
-  SUBDIRS += plugins/unity
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/unity/libstrongswan-unity.la
-endif
-endif
-
-if USE_UNIT_TESTS
-  SUBDIRS += plugins/unit_tester
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/unit_tester/libstrongswan-unit-tester.la
-endif
-endif
-
-if USE_XAUTH_GENERIC
-  SUBDIRS += plugins/xauth_generic
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/xauth_generic/libstrongswan-xauth-generic.la
-endif
-endif
-
-if USE_XAUTH_EAP
-  SUBDIRS += plugins/xauth_eap
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/xauth_eap/libstrongswan-xauth-eap.la
-endif
-endif
-
-if USE_XAUTH_PAM
-  SUBDIRS += plugins/xauth_pam
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/xauth_pam/libstrongswan-xauth-pam.la
-endif
-endif
-
-if USE_XAUTH_NOAUTH
-  SUBDIRS += plugins/xauth_noauth
-if MONOLITHIC
-  libcharon_la_LIBADD += plugins/xauth_noauth/libstrongswan-xauth-noauth.la
-endif
-endif
+endif
\ No newline at end of file
diff --git a/strongswan-5.2.0/src/libcharon/config/proposal.c b/strongswan-5.2.0/src/libcharon/config/proposal.c
index 4d881cd..94e4e1b 100644
--- a/strongswan-5.2.0/src/libcharon/config/proposal.c
+++ b/strongswan-5.2.0/src/libcharon/config/proposal.c
@@ -14,6 +14,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <string.h>
 
 #include "proposal.h"
@@ -26,6 +48,7 @@
 #include <crypto/prfs/prf.h>
 #include <crypto/crypters/crypter.h>
 #include <crypto/signers/signer.h>
+#include <crypto/key_transformer.h>
 
 ENUM(protocol_id_names, PROTO_NONE, PROTO_IPCOMP,
 	"PROTO_NONE",
@@ -280,7 +303,8 @@ METHOD(proposal_t, select_proposal, proposal_t*,
 		!select_algo(this, other, selected, PSEUDO_RANDOM_FUNCTION, private) ||
 		!select_algo(this, other, selected, INTEGRITY_ALGORITHM, private) ||
 		!select_algo(this, other, selected, DIFFIE_HELLMAN_GROUP, private) ||
-		!select_algo(this, other, selected, EXTENDED_SEQUENCE_NUMBERS, private))
+		!select_algo(this, other, selected, EXTENDED_SEQUENCE_NUMBERS, private) ||
+		!select_algo(this, other, selected, KEY_TRANSFORM_ALGORITHM, private))
 	{
 		selected->destroy(selected);
 		return NULL;
@@ -366,7 +390,8 @@ METHOD(proposal_t, equals, bool,
 		algo_list_equals(this, other, INTEGRITY_ALGORITHM) &&
 		algo_list_equals(this, other, PSEUDO_RANDOM_FUNCTION) &&
 		algo_list_equals(this, other, DIFFIE_HELLMAN_GROUP) &&
-		algo_list_equals(this, other, EXTENDED_SEQUENCE_NUMBERS));
+		algo_list_equals(this, other, EXTENDED_SEQUENCE_NUMBERS) &&
+		algo_list_equals(this, other, KEY_TRANSFORM_ALGORITHM));
 }
 
 METHOD(proposal_t, clone_, proposal_t*,
@@ -402,7 +427,7 @@ static const struct {
 	{AUTH_HMAC_SHA2_256_128,			PRF_HMAC_SHA2_256				},
 	{AUTH_HMAC_SHA2_384_192,			PRF_HMAC_SHA2_384				},
 	{AUTH_HMAC_SHA2_512_256,			PRF_HMAC_SHA2_512				},
-	{AUTH_HMAC_MD5_96,					PRF_HMAC_MD5					},
+	{AUTH_HMAC_MD5_96,					PRF_HMAC_MD5		 			},
 	{AUTH_AES_XCBC_96,					PRF_AES128_XCBC					},
 	{AUTH_CAMELLIA_XCBC_96,				PRF_CAMELLIA128_XCBC			},
 	{AUTH_AES_CMAC_96,					PRF_AES128_CMAC					},
@@ -583,6 +608,8 @@ int proposal_printf_hook(printf_hook_data_t *data, printf_hook_spec_t *spec,
 						 diffie_hellman_group_names, &first);
 	written += print_alg(this, data, EXTENDED_SEQUENCE_NUMBERS,
 						 extended_sequence_numbers_names, &first);
+	written += print_alg(this, data, KEY_TRANSFORM_ALGORITHM,
+						 key_transform_algorithm_names, &first);
 	return written;
 }
 
@@ -634,6 +661,7 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 	integrity_algorithm_t integrity;
 	pseudo_random_function_t prf;
 	diffie_hellman_group_t group;
+	key_transform_alorithm_t tfmer;
 	const char *plugin_name;
 
 	if (aead)
@@ -670,6 +698,24 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 	}
 	else
 	{
+		/* first round, appending BY algos */
+		enumerator = lib->crypto->create_crypter_enumerator(lib->crypto);
+		while (enumerator->enumerate(enumerator, &encryption, &plugin_name))
+		{
+			switch (encryption)
+			{
+				case ENCR_BELT_CBC:
+				case ENCR_BELT_CFB:
+				case ENCR_BELT_CTR:
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 256);
+					break;
+				default:
+					break;
+			}
+		}
+		enumerator->destroy(enumerator);
+
+		/* second round, appending others */
 		enumerator = lib->crypto->create_crypter_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &encryption, &plugin_name))
 		{
@@ -690,6 +736,10 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 				case ENCR_DES:
 					/* no, thanks */
 					break;
+				case ENCR_GOST28147_CFB:
+				case ENCR_GOST28147_CTR:
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 256);
+					break;
 				default:
 					break;
 			}
@@ -701,6 +751,23 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 			return FALSE;
 		}
 
+		/* first round, appending BY algos */
+		enumerator = lib->crypto->create_signer_enumerator(lib->crypto);
+		while (enumerator->enumerate(enumerator, &integrity, &plugin_name))
+		{
+			switch (integrity)
+			{
+				case AUTH_BELT_HMAC:
+				case AUTH_BELT_MAC:
+					add_algorithm(this, INTEGRITY_ALGORITHM, integrity, 0);
+					break;
+				default:
+					break;
+			}
+		}
+		enumerator->destroy(enumerator);
+
+		/* second round, appending others */
 		enumerator = lib->crypto->create_signer_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &integrity, &plugin_name))
 		{
@@ -715,6 +782,10 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 				case AUTH_AES_CMAC_96:
 					add_algorithm(this, INTEGRITY_ALGORITHM, integrity, 0);
 					break;
+				case AUTH_BELT_HASH:
+				case AUTH_GOST_MAC:
+					add_algorithm(this, INTEGRITY_ALGORITHM, integrity, 0);
+					break;
 				default:
 					break;
 			}
@@ -734,6 +805,8 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 			case PRF_HMAC_MD5:
 			case PRF_AES128_XCBC:
 			case PRF_AES128_CMAC:
+			case PRF_BRNG_CTR_HBELT:
+			case PRF_BRNG_HMAC_HBELT:
 				add_algorithm(this, PSEUDO_RANDOM_FUNCTION, prf, 0);
 				break;
 			default:
@@ -771,6 +844,7 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 			case ECP_256_BP:
 			case ECP_384_BP:
 			case ECP_512_BP:
+			case ECP_256_BIGN:
 			case NTRU_112_BIT:
 			case NTRU_128_BIT:
 			case NTRU_192_BIT:
@@ -783,6 +857,20 @@ static bool proposal_add_supported_ike(private_proposal_t *this, bool aead)
 	}
 	enumerator->destroy(enumerator);
 
+	enumerator = lib->crypto->create_key_transformer_enumerator(lib->crypto);
+	while (enumerator->enumerate(enumerator, &tfmer, &plugin_name))
+	{
+		switch (tfmer)
+		{
+			case BELT_KEYREP_TRANSFORM:
+				add_algorithm(this, KEY_TRANSFORM_ALGORITHM, tfmer, 0);
+				break;
+			default:
+				break;
+		}
+	}
+	enumerator->destroy(enumerator);
+
 	return TRUE;
 }
 
@@ -803,17 +891,30 @@ proposal_t *proposal_create_default(protocol_id_t protocol)
 			}
 			break;
 		case PROTO_ESP:
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_BELT_CBC,   	  256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_BELT_CFB,   	  256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_BELT_CTR,   	  256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_GOST28147_CFB,   256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_GOST28147_CTR,   256);
 			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_AES_CBC,         128);
 			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_AES_CBC,         192);
 			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_AES_CBC,         256);
 			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_3DES,              0);
 			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_BLOWFISH,        256);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_MAC,          0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_HMAC,         0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_GOST_MAC,          0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_HASH,         0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_HMAC_SHA1_96,      0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_AES_XCBC_96,       0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_HMAC_MD5_96,       0);
 			add_algorithm(this, EXTENDED_SEQUENCE_NUMBERS, NO_EXT_SEQ_NUMBERS,  0);
 			break;
 		case PROTO_AH:
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_MAC,    		0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_HMAC,    		0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_GOST_MAC,    		0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_HASH,    		0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_HMAC_SHA1_96,      0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_AES_XCBC_96,       0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_HMAC_MD5_96,       0);
diff --git a/strongswan-5.2.0/src/libcharon/encoding/payloads/certreq_payload.c b/strongswan-5.2.0/src/libcharon/encoding/payloads/certreq_payload.c
index 6ac90a2..4b7acac 100644
--- a/strongswan-5.2.0/src/libcharon/encoding/payloads/certreq_payload.c
+++ b/strongswan-5.2.0/src/libcharon/encoding/payloads/certreq_payload.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <stddef.h>
 
@@ -116,9 +138,9 @@ METHOD(payload_t, verify, status_t,
 	{
 		if (this->data.len % HASH_SIZE_SHA1)
 		{
-			DBG1(DBG_ENC, "invalid X509 hash length (%d) in certreq",
+			DBG1(DBG_ENC, "unknown X509 hash length (%d) in certreq",
 				 this->data.len);
-			return FAILED;
+			return SUCCESS;
 		}
 	}
 	return SUCCESS;
@@ -208,6 +230,7 @@ METHOD(enumerator_t, keyid_enumerate, bool,
 	{
 		chunk->ptr = this->pos;
 		chunk->len = HASH_SIZE_SHA1;
+
 		return TRUE;
 	}
 	return FALSE;
diff --git a/strongswan-5.2.0/src/libcharon/encoding/payloads/proposal_substructure.c b/strongswan-5.2.0/src/libcharon/encoding/payloads/proposal_substructure.c
index 53e8cf3..c191e73 100644
--- a/strongswan-5.2.0/src/libcharon/encoding/payloads/proposal_substructure.c
+++ b/strongswan-5.2.0/src/libcharon/encoding/payloads/proposal_substructure.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <stddef.h>
 
@@ -171,6 +193,11 @@ typedef enum {
 	IKEV1_ENCR_CAST_CBC = 6,
 	IKEV1_ENCR_AES_CBC = 7,
 	IKEV1_ENCR_CAMELLIA_CBC = 8,
+	IKEV1_ENCR_GOST28147_CTR = 9,
+	IKEV1_ENCR_GOST28147_CFB = 10,
+	IKEV1_ENCR_BELT_CBC = 11,
+	IKEV1_ENCR_BELT_CFB = 12,
+	IKEV1_ENCR_BELT_CTR = 13,
 	/* FreeS/WAN proprietary */
 	IKEV1_ENCR_SERPENT_CBC = 65004,
 	IKEV1_ENCR_TWOFISH_CBC = 65005,
@@ -186,6 +213,10 @@ typedef enum {
 	IKEV1_HASH_SHA2_256 = 4,
 	IKEV1_HASH_SHA2_384 = 5,
 	IKEV1_HASH_SHA2_512 = 6,
+	IKEV1_BELT_HASH = 7,
+	IKEV1_GOST_MAC = 8,
+	IKEV1_BELT_MAC = 9,
+	IKEV1_BELT_HMAC = 10,
 } ikev1_hash_t;
 
 /**
@@ -221,6 +252,11 @@ typedef enum {
 	IKEV1_ESP_ENCR_SEED_CBC = 21,
 	IKEV1_ESP_ENCR_CAMELLIA = 22,
 	IKEV1_ESP_ENCR_NULL_AUTH_AES_GMAC = 23,
+	IKEV1_ESP_ENCR_GOST28147_CTR = 24,
+	IKEV1_ESP_ENCR_GOST28147_CFB = 25,
+	IKEV1_ESP_ENCR_BELT_CBC = 26,
+	IKEV1_ESP_ENCR_BELT_CFB = 27,
+	IKEV1_ESP_ENCR_BELT_CTR = 28,
 	/* FreeS/WAN proprietary */
 	IKEV1_ESP_ENCR_SERPENT = 252,
 	IKEV1_ESP_ENCR_TWOFISH = 253,
@@ -243,6 +279,10 @@ typedef enum {
 	IKEV1_ESP_AUTH_AES_128_GMAC = 11,
 	IKEV1_ESP_AUTH_AES_192_GMAC = 12,
 	IKEV1_ESP_AUTH_AES_256_GMAC = 13,
+	IKEV1_ESP_AUTH_BELT_HASH = 14,
+	IKEV1_ESP_AUTH_GOST_MAC = 15,
+	IKEV1_ESP_AUTH_BELT_MAC = 16,
+	IKEV1_ESP_AUTH_BELT_HMAC = 17,
 } ikev1_esp_auth_transid_it;
 
 /**
@@ -261,6 +301,10 @@ typedef enum {
 	IKEV1_AH_AES_128_GMAC = 11,
 	IKEV1_AH_AES_192_GMAC = 12,
 	IKEV1_AH_AES_256_GMAC = 13,
+	IKEV1_AH_BELT_HASH = 14,
+	IKEV1_AH_GOST_MAC = 15,
+	IKEV1_AH_BELT_MAC = 16,
+	IKEV1_AH_BELT_HMAC = 16,
 } ikev1_ah_transid_t;
 
 /**
@@ -591,6 +635,11 @@ static algo_map_t map_encr[] = {
 	{ IKEV1_ENCR_CAST_CBC,		ENCR_CAST },
 	{ IKEV1_ENCR_AES_CBC,		ENCR_AES_CBC },
 	{ IKEV1_ENCR_CAMELLIA_CBC,	ENCR_CAMELLIA_CBC },
+	{ IKEV1_ENCR_GOST28147_CTR,	ENCR_GOST28147_CTR },
+	{ IKEV1_ENCR_GOST28147_CFB,	ENCR_GOST28147_CFB },
+	{ IKEV1_ENCR_BELT_CBC,		ENCR_BELT_CBC },
+	{ IKEV1_ENCR_BELT_CFB,		ENCR_BELT_CFB },
+	{ IKEV1_ENCR_BELT_CTR,		ENCR_BELT_CTR },
 	{ IKEV1_ENCR_SERPENT_CBC,	ENCR_SERPENT_CBC },
 	{ IKEV1_ENCR_TWOFISH_CBC,	ENCR_TWOFISH_CBC },
 };
@@ -604,6 +653,10 @@ static algo_map_t map_integ[] = {
 	{ IKEV1_HASH_SHA2_256,		AUTH_HMAC_SHA2_256_128 },
 	{ IKEV1_HASH_SHA2_384,		AUTH_HMAC_SHA2_384_192 },
 	{ IKEV1_HASH_SHA2_512,		AUTH_HMAC_SHA2_512_256 },
+	{ IKEV1_BELT_HASH,			AUTH_BELT_HASH },
+	{ IKEV1_GOST_MAC,			AUTH_GOST_MAC },
+	{ IKEV1_BELT_MAC,			AUTH_BELT_MAC },
+	{ IKEV1_BELT_HMAC,			AUTH_BELT_HMAC },
 };
 
 /**
@@ -641,6 +694,11 @@ static algo_map_t map_esp_encr[] = {
 	{ IKEV1_ESP_ENCR_AES_GCM_16,			ENCR_AES_GCM_ICV16 },
 	{ IKEV1_ESP_ENCR_CAMELLIA,				ENCR_CAMELLIA_CBC },
 	{ IKEV1_ESP_ENCR_NULL_AUTH_AES_GMAC,	ENCR_NULL_AUTH_AES_GMAC },
+	{ IKEV1_ESP_ENCR_GOST28147_CTR,			ENCR_GOST28147_CTR },
+	{ IKEV1_ESP_ENCR_GOST28147_CFB,			ENCR_GOST28147_CFB },
+	{ IKEV1_ESP_ENCR_BELT_CBC,				ENCR_BELT_CBC },
+	{ IKEV1_ESP_ENCR_BELT_CFB,				ENCR_BELT_CFB },
+	{ IKEV1_ESP_ENCR_BELT_CTR,				ENCR_BELT_CTR },
 	{ IKEV1_ESP_ENCR_SERPENT,				ENCR_SERPENT_CBC },
 	{ IKEV1_ESP_ENCR_TWOFISH,				ENCR_TWOFISH_CBC },
 };
@@ -660,6 +718,11 @@ static algo_map_t map_esp_auth[] = {
 	{ IKEV1_ESP_AUTH_AES_128_GMAC,		AUTH_AES_128_GMAC },
 	{ IKEV1_ESP_AUTH_AES_192_GMAC,		AUTH_AES_192_GMAC },
 	{ IKEV1_ESP_AUTH_AES_256_GMAC,		AUTH_AES_256_GMAC },
+	{ IKEV1_ESP_AUTH_BELT_HASH,			AUTH_BELT_HASH },
+	{ IKEV1_ESP_AUTH_GOST_MAC,			AUTH_GOST_MAC },
+	{ IKEV1_ESP_AUTH_BELT_MAC,			AUTH_BELT_MAC },
+	{ IKEV1_ESP_AUTH_BELT_HMAC,			AUTH_BELT_HMAC },
+
 };
 
 /**
@@ -676,6 +739,10 @@ static algo_map_t map_ah[] = {
 	{ IKEV1_AH_AES_128_GMAC,	AUTH_AES_128_GMAC },
 	{ IKEV1_AH_AES_192_GMAC,	AUTH_AES_192_GMAC },
 	{ IKEV1_AH_AES_256_GMAC,	AUTH_AES_256_GMAC },
+	{ IKEV1_AH_BELT_HASH,		AUTH_BELT_HASH },
+	{ IKEV1_AH_GOST_MAC,		AUTH_GOST_MAC },
+	{ IKEV1_AH_BELT_MAC,		AUTH_BELT_MAC },
+	{ IKEV1_AH_BELT_HMAC,		AUTH_BELT_HMAC },
 };
 
 /**
@@ -1499,6 +1566,16 @@ static void set_from_proposal_v2(private_proposal_substructure_t *this,
 		add_transform_substructure(this, transform);
 	}
 	enumerator->destroy(enumerator);
+
+	/* key transform algorithms (keyrep) */
+	enumerator = proposal->create_enumerator(proposal, KEY_TRANSFORM_ALGORITHM);
+	while (enumerator->enumerate(enumerator, &alg, NULL))
+	{
+		transform = transform_substructure_create_type(PLV2_TRANSFORM_SUBSTRUCTURE,
+												KEY_TRANSFORM_ALGORITHM, alg);
+		add_transform_substructure(this, transform);
+	}
+	enumerator->destroy(enumerator);
 }
 
 /**
@@ -1675,3 +1752,4 @@ proposal_substructure_t *proposal_substructure_create_for_ipcomp_v1(
 
 	return &this->public;
 }
+
